/************************************************************************/
/*									*/
/*			Clock / Calendar				*/
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/

#include "main.h"
#include "clock.h"
#include "timebase.h"
#include "dcf77.h"

struct time data time;


const u8 code MDAYS[] = {
    29, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

u8 is_cet(void)
{
	return ((time.flags & FLAG_CET) && !(time.flags & FLAG_CEST));
}

u8 is_cest(void)
{
	return ((time.flags & FLAG_CEST) && !(time.flags & FLAG_CET));
}

void clock(void)
{
  u8 i;

  time.second++;
  if( time.second >= 60 ){
    if (time.flags & FLAG_LEAP_SECOND && time.second == 60) {
      return;
    }
    time.second = 0;
    timeflags = 1<<ONE_MINUTE;		// to correct deviation per minute
    time.minute++;
    if( time.minute == 60 ){
      time.minute = 0;
      time.hour++;
      if (time.hour == 24) {
	  time.hour = 0;
	  time.day++;
	  time.wday++;
	  if( time.wday == 8 )
	    time.wday = 1;
	  i = time.month;
	  if( i == 2 && !(time.year % 4) )	// leap year
	    i = 0;
	  if( LPM(MDAYS+i) < time.day ){
	    time.day = 1;
	    time.month++;
	    if( time.month == 13 ){
	      time.month = 1;
	      time.year++;
	      if( time.year == 100 )
	        time.year = 0;			// next century
	    }
	  }
      }
      if (time.flags & FLAG_SUMMERTIME_PENDING) {
		if (is_cet() && time.hour == 2) {
			time.hour = 3;
		}
		if (is_cest() && time.hour == 3) {
			time.hour = 2;
		}
      }
    }
  }
}

